## org.apache.commons.collections
Interface Bag

All Superinterfaces:
  java.util.Collection, java.lang.Iterable

All Known Subinterfaces:
  SortedBag

All Known Implementing Classes:
  AbstractBagDecorator, AbstractMapBag, AbstractSortedBagDecorator, DefaultMapBag, HashBag, HashBag, PredicatedBag, PredicatedSortedBag, SynchronizedBag, SynchronizedSortedBag, TransformedBag, TransformedSortedBag, TreeBag, TreeBag, UnmodifiableBag, UnmodifiableSortedBag

    public interface Bag

extends java.util.Collection

Defines a collection that counts the number of times an object appears in the collection.

Suppose you have a Bag that contains `{a, a, b, c}`. Calling `getCount(Object)` on `a` would return 2, while calling `uniqueSet()` would return `{a, b, c}`.

NOTE: This interface violates the `Collection` contract. The behavior specified in many of these methods is not the same as the behavior specified by `Collection`. The noncompliant methods are clearly marked with "(Violation)". Exercise caution when using a bag as a `Collection`.

This violation resulted from the original specification of this interface. In an ideal world, the interface would be changed to fix the problems, however it has been decided to maintain backwards compatibility instead.

Since:
  Commons Collections 2.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Chuck Burdick, Stephen Colebourne

Method Summary
`boolean` `add(java.lang.Object object)` (Violation) Adds one copy the specified object to the Bag.
`boolean` `add(java.lang.Object object, int nCopies)` Adds `nCopies` copies of the specified object to the Bag.
`boolean` `containsAll(java.util.Collection coll)` (Violation) Returns `true` if the bag contains all elements in the given collection, respecting cardinality.
`int` `getCount(java.lang.Object object)` Returns the number of occurrences (cardinality) of the given object currently in the bag.
`java.util.Iterator` `iterator()` Returns an `Iterator` over the entire set of members, including copies due to cardinality.
`boolean` `remove(java.lang.Object object)` (Violation) Removes all occurrences of the given object from the bag.
`boolean` `remove(java.lang.Object object, int nCopies)` Removes `nCopies` copies of the specified object from the Bag.
`boolean` `removeAll(java.util.Collection coll)` (Violation) Remove all elements represented in the given collection, respecting cardinality.
`boolean` `retainAll(java.util.Collection coll)` (Violation) Remove any members of the bag that are not in the given collection, respecting cardinality.
`int` `size()` Returns the total number of items in the bag across all types.
`java.util.Set` `uniqueSet()` Returns a `Set` of unique elements in the Bag.

Methods inherited from interface java.util.Collection
`addAll, clear, contains, equals, hashCode, isEmpty, toArray, toArray`

Method Detail

### getCount

    int getCount(java.lang.Object object)

  Returns the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.

  Parameters:
    `object` - the object to search for
  Returns:
    the number of occurrences of the object, zero if not found

### add

    boolean add(java.lang.Object object)

  (Violation) Adds one copy the specified object to the Bag.

  If the object is already in the `uniqueSet()` then increment its count as reported by `getCount(Object)`. Otherwise add it to the `uniqueSet()` and report its count as 1.

  Since this method always increases the size of the bag, according to the `Collection.add(Object)` contract, it should always return `true`. Since it sometimes returns `false`, this method violates the contract.

  Specified by:
    `add` in interface `java.util.Collection`
  Parameters:
    `object` - the object to add
  Returns:
    `true` if the object was not already in the `uniqueSet`

### add

    boolean add(java.lang.Object object,
                int nCopies)

  Adds `nCopies` copies of the specified object to the Bag.

  If the object is already in the `uniqueSet()` then increment its count as reported by `getCount(Object)`. Otherwise add it to the `uniqueSet()` and report its count as `nCopies`.

  Parameters:
    `object` - the object to add
    `nCopies` - the number of copies to add
  Returns:
    `true` if the object was not already in the `uniqueSet`

### remove

    boolean remove(java.lang.Object object)

  (Violation) Removes all occurrences of the given object from the bag.

  This will also remove the object from the `uniqueSet()`.

  According to the `Collection.remove(Object)` method, this method should only remove the first occurrence of the given object, not all occurrences.

  Specified by:
    `remove` in interface `java.util.Collection`
  Returns:
    `true` if this call changed the collection

### remove

    boolean remove(java.lang.Object object,
                   int nCopies)

  Removes `nCopies` copies of the specified object from the Bag.

  If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

  Parameters:
    `object` - the object to remove
    `nCopies` - the number of copies to remove
  Returns:
    `true` if this call changed the collection

### uniqueSet

    java.util.Set uniqueSet()

  Returns a `Set` of unique elements in the Bag.

  Uniqueness constraints are the same as those in `Set`.

  Returns:
    the Set of unique Bag elements

### size

    int size()

  Returns the total number of items in the bag across all types.

  Specified by:
    `size` in interface `java.util.Collection`
  Returns:
    the total size of the Bag

### containsAll

    boolean containsAll(java.util.Collection coll)

  (Violation) Returns `true` if the bag contains all elements in the given collection, respecting cardinality. That is, if the given collection `coll` contains `n` copies of a given object, calling `getCount(Object)` on that object must be `>= n` for all `n` in `coll`.

  The `Collection.containsAll(Collection)` method specifies that cardinality should not be respected; this method should return true if the bag contains at least one of every object contained in the given collection.

  Specified by:
    `containsAll` in interface `java.util.Collection`
  Parameters:
    `coll` - the collection to check against
  Returns:
    `true` if the Bag contains all the collection

### removeAll

    boolean removeAll(java.util.Collection coll)

  (Violation) Remove all elements represented in the given collection, respecting cardinality. That is, if the given collection `coll` contains `n` copies of a given object, the bag will have `n` fewer copies, assuming the bag had at least `n` copies to begin with.

  The `Collection.removeAll(Collection)` method specifies that cardinality should not be respected; this method should remove all occurrences of every object contained in the given collection.

  Specified by:
    `removeAll` in interface `java.util.Collection`
  Parameters:
    `coll` - the collection to remove
  Returns:
    `true` if this call changed the collection

### retainAll

    boolean retainAll(java.util.Collection coll)

  (Violation) Remove any members of the bag that are not in the given collection, respecting cardinality. That is, if the given collection `coll` contains `n` copies of a given object and the bag has `m > n` copies, then delete `m - n` copies from the bag. In addition, if `e` is an object in the bag but `!coll.contains(e)`, then remove `e` and any of its copies.

  The `Collection.retainAll(Collection)` method specifies that cardinality should not be respected; this method should keep all occurrences of every object contained in the given collection.

  Specified by:
    `retainAll` in interface `java.util.Collection`
  Parameters:
    `coll` - the collection to retain
  Returns:
    `true` if this call changed the collection

### iterator

    java.util.Iterator iterator()

  Returns an `Iterator` over the entire set of members, including copies due to cardinality. This iterator is fail-fast and will not tolerate concurrent modifications.

  Specified by:
    `iterator` in interface `java.util.Collection`
  Specified by:
    `iterator` in interface `java.lang.Iterable`
  Returns:
    iterator over all elements in the Bag

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.